# Try to see if the system should stay up.  The reasons for startup are:
#    Power On Button (least likely)
#    Secret keyboard code
#    Wake on LAN (likely)
#    Scheduled startup by mythbackend (most likely)
#
# The system should shutdown if:
#    MythTV Backend is idle, (implies the combined Frontend isn't running)
#    The Network Control port isn't in use
#    The Diskless Client isn't up
#

SHUTDOWN_LOG="/var/log/mythtv/LocalPreShutdownTests.log"
DATE=`date +'%x %X'`

# See if mythbackend thinks its ok to shutdown
#    0 OK to shutdown
#    1 Don't shutdown

mythshutdown --quiet --syslog none --nodblog --check
MYTH_SD=$?

# See if port 6546 is active
#    0 = Active, Don't shutdown
#    1 = Inactive, OK to shutdown

netstat -an | grep "192.168.1.204:6546.*192.168.1.20[1-9]:.*ESTABLISHED" 2>&1 > /dev/null
NC=$?

# See if the diskless client is running
#     0 its running    (don't shutdown)
#    !0 it isn't       (OK to shutdown)

FE=1
for FEHOST in fe1
do  ping -c1 -q -t4 -w1 ${FEHOST} 2>&1 > /dev/null
    if [ $? = 0 ]; then
        FE=0
    fi
done

# See if the slave backend is active
#    0 = Active, Don't shutdown
#    1 = Inactive, OK to shutdown

netstat -an | grep "192.168.1.204:6543.*192.168.1.200:.*ESTABLISHED" 2>&1 > /dev/null
SBE=$?

# Now adjust this script's return code for mythbackend's use.

if [ $MYTH_SD -eq 0 -a $NC = 1 -a $FE != 0 -a $SBE -eq 1 ]; then
    echo "$DATE: SD=$MYTH_SD, 0=OK, NETCTL=$NC, 1=OK, DC=$FE, !0=OK, SBE=$SBE, 1=OK, OK To Shutdown." >> ${SHUTDOWN_LOG}
    exit 0
else    #echo "$DATE: SD=$MYTH_SD, 0=OK, NETCTL=$NC, 1=OK, DC=$FE, !0=OK, SBE=$SBE, 1=OK Don't Shutdown." >> ${SHUTDOWN_LOG}
    exit 1
fi
